package test;

import net.eduvax.util.SortedList;

import org.junit.*;
import static org.junit.Assert.*;

public class TestSortedList {
	@Before public void setUp() {
	}
	@After public void tearDown() {
	}
	@Test public void testAddSeq() {
		String[] samples={"b","a","c","f","e"};
		SortedList<String> slist=new SortedList<String>();
		for(int i=0;i<samples.length;i++) {
			slist.add(samples[i]);
		}
		String[] popseq=new String[samples.length];
		assertEquals("Size",samples.length,slist.size());
		for (int i=0;i<popseq.length;i++) {
			popseq[i]=slist.popHead();
			assertEquals("Size",samples.length-(i+1),slist.size());
		}
		assertEquals("a",popseq[0]);
		assertEquals("b",popseq[1]);
		assertEquals("c",popseq[2]);
		assertEquals("e",popseq[3]);
		assertEquals("f",popseq[4]);

	}
	@Test public void testAddRemoveSeq() {
		String[] samples={"b","a","c","f","e"};
		SortedList<String> slist=new SortedList<String>();
		for(int i=0;i<samples.length;i++) {
			slist.add(samples[i]);
		}
		String[] popseq=new String[samples.length];
		assertEquals("Size",samples.length,slist.size());
		for (int i=0;i<popseq.length;i++) {
			popseq[i]=slist.head();
			slist.remove(popseq[i]);
			assertEquals("Size",samples.length-(i+1),slist.size());
		}
		assertEquals("a",popseq[0]);
		assertEquals("b",popseq[1]);
		assertEquals("c",popseq[2]);
		assertEquals("e",popseq[3]);
		assertEquals("f",popseq[4]);
	}
}
